Description

During plugin development | found out that the definition of the Query class accesses the database just by being defined.
The reason for this is the “groupable” method in the "TimestampQueryColumn’ class which tries to access the current user.

https://github.com/redmine/redmine/blob/4.1.1/app/models/query.rb#l 89-1 93

This method is called during the constructor (which is called in the query column definitions in the class body of IssueQuery)

https://github.com/redmine/redmine/blob/4.1.1/app/models/issue_query.rb#l 36-L51

Why is this a problem?

In case your database is not yet created and/or migrated, any source code which just references the IssueQuery class will raise an
exception since it cannot find the database/table.

And in general | think it's not good to access the database just by defining a class.

Patch

| attached a patch which also acts as a code cleanup/refactoring. It moves the group by statement into its own method. Before the
boolean property "groupable’ was just redefined to contain the group by statement as well, which was confusing in the first place in
my opinion.

I ran all tests locally and they passed.

Related issues:

Related to Redmine - Feature #2679: Ticket grouping Closed 2009-02-05
Related to Redmine - Feature #13803: Implement grouping issues by date (start... Closed
Related to Redmine - Defect #35115: Time entries are broken if grouped by pro... Closed
Has duplicate Redmine - Defect #33121: IssueQuery not usable from plugins Closed

Associated revisions

Revision 20830 - 2021-03-19 06:20 - Go MAEDA

Unnecessary database access when IssueQuery class is defined (#33290).

Patch by Kevin Fischer.

History

#1 - 2020-04-15 10:59 - Go MAEDA
- Related to Feature #2679: Ticket grouping added

#2 - 2020-04-15 11:40 - Kevin Fischer
This only happens from Redmine 4.1 by the way.

The commit bringing the change was r17724

#3 - 2020-04-15 14:19 - Alexander Meindl
https://github.com/redmine/redmine/blob/4.1.1/app/models/query.rb#L89-L93
https://github.com/redmine/redmine/blob/4.1.1/app/models/issue_query.rb#L36-L51
https://www.redmine.org/projects/redmine/repository/svn/revisions/17724

| can confirm this problem with Redmine 4.1. It is very difficult to test plugins with the bug.

#4 - 2020-04-15 16:03 - Go MAEDA
- Related to Feature #13803: Implement grouping issues by date (start, due, creation, update, closing dates) added

#5 - 2020-07-07 04:36 - Kevin Fischer

Is there any chance this change will be considered for the next version?

If you reference the IssueQuery class in a plugin's init.rb file (to include a module with new functionality) it becomes impossible to create a new
database (which is very inconvenient when running for example tests on a Cl system) since the system complains about the User table not yet
existing.

A class definition should not need to access the database.

#6 - 2021-01-16 05:55 - Kevin Fischer

Trying the patch out with the most recent master, the tests don't seem to pass for SQLite.
| will fix the patch and post an updated version soon.

#7 - 2021-01-24 22:59 - Marius BALTEANU
- Related to Defect #33121: IssueQuery not usable from plugins added

#8 - 2021-01-24 22:59 - Marius BALTEANU
- Category set to Plugin AP/
- Assignee set to Jean-Philippe Lang

- Target version set to 4.1.2

Jean-Philippe, can you take a look on this and the related issue (#33121)?

#9 - 2021-02-05 11:55 - Kevin Fischer

- File 0001-stop-db-access-on-class-definition-v2.patch added

| fixed the patch so it works for SQLite, too. Also, | refactored the code around “groupable’ a little bit more to make it more obvious that it is a boolean
property.

#10 - 2021-03-15 22:23 - Marius BALTEANU
- Target version changed from 4.1.2 to 4.2.0

I'm assigning this to 4.2.0 because the changes are too big for a minor version.

#11 - 2021-03-18 19:21 - Marius BALTEANU
- Related to deleted (Defect #33121: IssueQuery not usable from plugins)

#12 - 2021-03-18 19:21 - Marius BALTEANU
- Has duplicate Defect #33121: IssueQuery not usable from plugins added

#13 - 2021-03-18 20:08 - Marius BALTEANU
- Tracker changed from Patch to Defect
- Status changed from New to Confirmed

- Assignee changed from Jean-Philippe Lang to Go MAEDA

I've confirmed the issue and the second patch posted by Kevin looks good to me. All tests pass:
https://qgitlab.com/redmine-org/redmine/-/pipelines/272847174

#14 - 2021-03-19 06:21 - Go MAEDA
- Status changed from Confirmed to Closed

- Resolution set to Fixed

Committed the fix. Thank you for your contribution.

2025-07-02 2/3


https://www.redmine.org/issues/33121
https://www.redmine.org/versions/152
https://gitlab.com/redmine-org/redmine/-/pipelines/272847174

#15 - 2021-03-19 06:22 - Go MAEDA

- Subject changed from Stop DB access when IssueQuery class is defined to Unnecessary database access when IssueQuery class is defined

#16 - 2021-04-21 09:23 - Go MAEDA

- Related to Defect #35115: Time entries are broken if grouped by project and issue custom fields added

Files
0001-stop-db-access-on-class-definition.patch 1.65 KB 2020-04-15 Kevin Fischer
0001-stop-db-access-on-class-definition-v2.patch 3.08 KB 2021-02-05 Kevin Fischer
